////////////////////////////////////////////////////////////////////////
// ggs.c
// Affichage d'une annimation en 20 images
// Mode 0
// repernsente la dense Gangnam Style !!!
////////////////////////////////////////////////////////////////////////

#define  SCR_SET_MODE0_s \
	__asm	ld a,#0 \
	call #0xBC0E \
	__endasm;



// IL FAUT UTILISER "--oldralloc" POUR COMPILER !
// code retout :
// 0 Ok
// -1 Erreur
int ReadFileBin(char* filename, char* readbuffer)
{

__asm

	; Initialisation de l amsdos (ROM 7) avant le changement d un fichier
	ld   	hl,(#0xBE7D)	; adresse de la zone rserve AMSDOS
	ld   	a,(hl)			; drive
	push 	hl
	push 	af
	ld      de,#0x40		;DE-HL contient la plage dans laquelle la rom doit tre recherche
	ld      hl,#0xABFF
	ld      c,#7			;contient l adresse de slection de rom  tester
	call    #0xBCCE			;initialisation d une rom de second plan
	pop		af
	pop		hl
	ld		(hl),a			; on remet le drive courant
	
	; rcupere le parametre char* filename
	LD L, 4(IX)
	LD H, 5(IX)
	;LD B, 8(IX)
	
	; calcule la longeur du nom de fichier
	call getfilenamesize
	
	; B = longueur du nom de fichier en caractres
	; HL = l adresse de dbut du nom de fichier
	
	;; DE = l adresse d un tampon 2k
	;; En mode disque: cette mmoire tampon n est pas utilis lorsque Fonction firmware 
	;; CAS EN DIRECT est utilis, il est donc prudent de le mettre nulle (0)
	;; Vous le souhaitez.
	ld de,#0

	;; fonction du firmware pour ouvrir un fichier en lecture
	call #0xbc77

	;; cas_in_open retour:
	;; si le fichier a t ouvert avec succs:
	;; - carry est vrais
	;; - HL contient l adresse de l en-tte du fichier s AMSDOS
	;; - DE contient l adresse de chargement du fichier ( partir de l en-tte)
	;; - BC contient la longueur du fichier ( partir de l en-tete du fichier)
	;; - A contient le type de fichier (2 pour les fichiers binaires)
	; si une erreur on sort le la fonction
    JR NC,ERRDRIV
    JR Z,ERRDRIV
	
	;; fonction du firmware pour charger le fichier en entier
	;; cela fonctionne avec les fichiers qui ont un en-tte AMSDOS (les
	;; fichiers ASCII n ont pas un en-tte)
	
	; rcupere le parametres char* readbuffer
	LD L, 6(IX)
	LD H, 7(IX)

	;; Lecture du fichier
	call #0xbc83

	;; fonction du firmware pour fermer un fichier ouvert en lecture
	call #0xbc7a
	
	jp asmFin

ERRDRIV:
	;LD (FLGERR),A  ;Sort ici si erreur drive
	CALL #0xBC7D
	; il y a une erreur, on retourne cette erreur....
	; enfin pour le moment juste la valeur -1
	ld	hl,#0xFFFF
	pop	ix
	ret
	
	
getfilenamesize:
	push de
	push hl
	ld e,#0
getfilenamesizeloop:
	ld a, (hl)
	or a
	jp z, getfilenamesizeend
	inc hl
	inc e
	jp getfilenamesizeloop
getfilenamesizeend:
	pop hl
	ld b, e
	pop de
	ret	
	
asmFin: 
 	
 __endasm;

 return 0;
}

void SetColor_s(unsigned char NoEncre, unsigned char color)
{
	//A contient le numero de l'encre ; B est la premiere couleur, C la seconde, masi la =  la premire
	__asm
		ld  a, 4(IX)
		ld  b, 5(IX)
		ld  c, 5(IX)
		call #0xBC32
	__endasm;
}

void WaitVbl()
{
__asm
        ld b,#0xF5          ; On selectionne le Port B du PPI
_Synchro: in a,(c)          ; On pique son contenu
        rra               ; On teste si le Bit0=1
        jp nc,_Synchro    ; Si Bit0=0 alors on attend la fin
                          ; du balayage
__endasm;
}

char nGetChar;
char GetChar()
{
  __asm
    LD HL, #_nGetChar
    LD (HL), #0
    CALL #0xBB09 ;KM READ CHAR
    JP NC, _end_getchar
    LD (HL), A
    _end_getchar:
  __endasm;
  
  return nGetChar;
}



void PutSpriteMode0(unsigned char *pAddress, unsigned char nWidth, unsigned char nHeight, unsigned char *pSprite)
{
	__asm
		LD L, 4(IX)   ; adr ecran
		LD H, 5(IX) 
		LD C, 6(IX)   ; Largeur
		LD B, 7(IX)   ; hauteur         
		LD E, 8(IX)   ; adr du sprite
		LD D, 9(IX) 

		_loop_alto:
		   PUSH BC
		   LD B,C
		   PUSH HL
		_loop_ancho:
		   LD A,(DE)
		   LD (HL),A
		   INC DE
		   INC HL
		   DJNZ _loop_ancho
		   POP HL
		   LD A,H
		   ADD #0x08
		   LD H,A
		   SUB #0xC0
		   JP NC, _sig_linea
		   LD BC, #0xC050
		   ADD HL,BC
		_sig_linea:
		   POP BC
		   DJNZ _loop_alto
	__endasm;
}


/*
// cela fonctionne aussi mais c'est beaucoup plus lent
void PutSpriteMode0(unsigned char *pSprite, unsigned char nX, unsigned char nY, unsigned char nWidth, unsigned char nHeight)
{
  unsigned char nXPos = 0;
  unsigned char nYPos = 0;
  unsigned char *pAddress = 0;
  
  for(nYPos = 0; nYPos < nHeight; nYPos++)
  {
    pAddress = (unsigned char *)(0xC000 + ((nY / 8u) * 80u) + ((nY % 8u) * 2048u) + nX);

    for(nXPos = 0; nXPos < nWidth; nXPos++)
      *pAddress++ = *pSprite++;

    nY++;
  }
}
*/

void main()
{
	unsigned char CurSprite = 0;
	char nChar;
	unsigned char *TabpAddspr[20];
	unsigned char i;
	
	// l'adresse de dpar sur l'ecan est toujour la mme, la on la calcule mais on c'est pas trs util !
	// on l'affiche  peut prs centr dans l'cra,n.
	// le sprite fait 40*98
	// (160-40) / 2 = 50 en X
	// (200 - 98) / 2 = 51 en Y
	unsigned char *pAddress = (unsigned char *)((unsigned int)(0xC000 + ((50 / 8) * 80) + ((50 % 8) * 2048) + (150 / 4)));

	// chargement des data pour images.
	// Le fichier est de type binaire, data sprite linaire
	// on les charge  partir de 1000  bFFF
	ReadFileBin( "ggsdata.bin", 0x1000);

    //SCR_SET_MODE 0
    SCR_SET_MODE0_s;
	
	// initalisation du tableau des adresse de sprite
	for (i = 0; i < 20; i++)
	{
		TabpAddspr[i] = (unsigned char *)((unsigned int)(i*(10*98) + 0x1000) );
	}
	
	// on met les couleurs.
	SetColor_s(0,26);
	SetColor_s(1,0);
	SetColor_s(2,13);
	SetColor_s(3,4);
	SetColor_s(4,12);
	SetColor_s(5,16);
	SetColor_s(6,25);
	SetColor_s(7,10);
	SetColor_s(8,3);
	SetColor_s(9,14);
	SetColor_s(10,1);
	SetColor_s(11,23);
	SetColor_s(12,11);
	SetColor_s(13,2);
	SetColor_s(14,5);
	SetColor_s(15,6);
	
	
	// on fait l'animation.
	while( 1 )
	{
		nChar = GetChar();
		if ( nChar != 0 )
			break;
	
		if ( CurSprite > 19 )
			CurSprite = 0;

		// pous eviter le cliping, on attent la prochaine image
		WaitVbl();
		
		// on copie le sprite  l'cran
		// le sprite fait 40*98 donc 10 colonnes et 98 lignes.
		PutSpriteMode0( pAddress, 10, 98, (unsigned char *)TabpAddspr[CurSprite] );
		
		// cela fonctionne aussi mais c'est beaucoup plus lent
		//PutSpriteMode0( (unsigned char *)(0x1000+(CurSprite*(10*98))), 50,51, 10,98 );

		CurSprite++;

		// attente de 3 image avant de continuer
		WaitVbl();
		WaitVbl();
		WaitVbl();
	}

}




